/*
 * File         : test6.java
 * Author       : Guansong Zhang
 * Created      : Wed Jan 14 10:28:34 1998
 * Revision     : $Revision: 1.5 $
 * Updated      : $Date: 1998/09/29 19:48:28 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

//   !hpf$ processors p(2, 2)
//
//   integer a(6, 4)
//   !hpf$ distribute a(block, block) onto p
//
//   !hpf$ template s(10, 4)
//   !hpf$ distribute s(cyclic, block) onto p
//
//   integer b(6, 4)
//   !hpf$ align b(i, j) with s(1 + i, j)
//
//   integer i, j, k
//
//   do i = 1, 6
//     do j = 1, 4
//       a(i, j) = 100 * (i - 1) + 10 * (j - 1)
//     enddo
//   enddo
//
//   b = a
//
//   do i = 1, 6
//     do j = 1, 4
//       print "(i3, i3, i10)", i - 1, j - 1, b(i, j)
//     enddo
//   enddo
//
// end

import hpjava.spmd.*;
import hpjava.spmd.adlib.*;
import hpjava.lang.*;

class test6 {
  static SpmdEnv spmd;
  static Procs2 p;
  static BlockRange x,y;
  static Array2ddI a,b;
  static Range z; 
  // Range z = new CyclicRange (10, p.dim(0)).subrng(6, 1);

  public static void main(String argv[]) {
    spmd = new SpmdEnv (argv);

    p=new Procs2(2,2);

    if (p.on()) {

      x = new BlockRange (6, p.dim(0));
      y = new BlockRange (4, p.dim(1));

      a = new Array2ddI(spmd.apg, x, y);

      z = new CyclicRange (10, p.dim(0)).subrng(6, 1);

      Array2ddI b = new Array2ddI(spmd.apg,z, y);
      
      Index i = new Index (x);
      Index j = new Index (y);

      i.dim().over();
      for (i.begin(); i.test(); i.next()) {
	j.dim().over();
	for (j.begin(); j.test(); j.next()) {
	  a.dat()[a.pos(i, j)]= 100*x.idx(i) + 10*y.idx(j);
	  //	  System.out.println(a.dat()[a.pos(i,j)]);
	} j.dim().revo();
      } i.dim().revo();

      //      Adlib.aprintf("%3R0%3R1%10d\n", a);

      Adlib.remap(b, a);

      Adlib.aprintf("%3R0%3R1%10d\n", b);

    } p.no();

    spmd.finalize();

  }
}
